% Created by: Syed Zain Masood
% Date: 30th April, 2009
% This code is intended to remove saturation effects from photographs

function X = CrossChannel(img,num,denom,other,satMap)

[m n o] = size(img);
pix = m*n;
imgSize = pix;


% First constraint ==> for example, wRG1(alpha - R/G)^2
A1 = speye(pix);
img(:,:,denom) = img(:,:,denom)+0.00001;
temp = img(:,:,num)./img(:,:,denom);
b1 = reshape(temp,pix,1);
w1 = (~satMap(:,:,num) & ~satMap(:,:,denom));
diagw1 = spdiags(w1(:),0,length(w1(:)),length(w1(:)));

M = A1'*diagw1*A1;
N = A1'*diagw1*b1;

clear A1 diagw1

% Avoiding Matrix M becoming singular
M=M+0.00001*speye(size(M,1));

% Solving the initial system
alpha = M\N;
alpha = reshape(alpha,m,n);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Levin's Approach for neighbouring ratio information.

w2 = 1-w1;
indsM=reshape([1:imgSize],m,n);
lblInds=find(~w2);

wd=1; 
len=0;
consts_len=0;
col_inds=zeros(imgSize*(2*wd+1)^2,1);
row_inds=zeros(imgSize*(2*wd+1)^2,1);
vals=zeros(imgSize*(2*wd+1)^2,1);
gvalsR=zeros(1,(2*wd+1)^2);
gvalsG=zeros(1,(2*wd+1)^2);
gvalsB=zeros(1,(2*wd+1)^2);
temp = zeros(1,9);
sat_vec = zeros(3,8);

for j=1:n
   for i=1:m
       
       if i==6 & j==14
           tmp=0;
       end
       
      consts_len=consts_len+1;
      if (w2(i,j))   
        tlen=0;
        for ii=max(1,i-wd):min(i+wd,m)
           for jj=max(1,j-wd):min(j+wd,n)
               
               if ii==5 & jj==15
                    tmp=0;
                end
            
              if (ii~=i)|(jj~=j)
                len=len+1; tlen=tlen+1;
                row_inds(len)= consts_len;
                col_inds(len)=indsM(ii,jj);
                sat_vec(:,tlen) = ~satMap(ii,jj,:);
                
                % If only R not saturated, use R for weights.
                if(~satMap(i,j,num) & satMap(i,j,denom) & satMap(i,j,other))
                    if(~satMap(ii,jj,num))
                        gvalsR(tlen)=img(ii,jj,num);
                    end
                    number = 1;
                
                % If only G not saturated, use G for weights.
                elseif(satMap(i,j,num) & ~satMap(i,j,denom) & satMap(i,j,other))
                    if(~satMap(ii,jj,denom))
                        gvalsG(tlen)=img(ii,jj,denom);
                    end
                    number = 1;
                
                % If only B not saturated, use B for weights.
                elseif(satMap(i,j,num) & satMap(i,j,denom) & ~satMap(i,j,other))
                    if(~satMap(ii,jj,other))
                        gvalsB(tlen)=img(ii,jj,other);
                    end
                    number = 1;
                
                % If only R and B not saturated, use R+B for weights.
                elseif(~satMap(i,j,num) & satMap(i,j,denom) & ~satMap(i,j,other))
                    if(~satMap(ii,jj,num))
                        gvalsR(tlen)=img(ii,jj,num);
                    end
                    if(~satMap(ii,jj,other))
                        gvalsB(tlen)=img(ii,jj,other);
                    end
                    number = 2;
                
                % If only G and B not saturated, use G+B for weights.
                elseif(satMap(i,j,num) & ~satMap(i,j,denom) & ~satMap(i,j,other))
                    if(~satMap(ii,jj,denom))
                        gvalsG(tlen)=img(ii,jj,denom);
                    end
                    if(~satMap(ii,jj,other))
                        gvalsB(tlen)=img(ii,jj,other);
                    end
                    number = 2;

                % If only R and G not saturated, use R+G for weights.
                elseif(~satMap(i,j,num) & ~satMap(i,j,denom) & satMap(i,j,other))
                    if(~satMap(ii,jj,num))
                        gvalsR(tlen)=img(ii,jj,num);
                    end
                    if(~satMap(ii,jj,denom))
                        gvalsG(tlen)=img(ii,jj,denom);
                    end
                    number = 2;

                % If all color channels of pixel saturated.
                else
                    if(~satMap(ii,jj,num))
                        gvalsR(tlen)=img(ii,jj,num);
                    end
                    if(~satMap(ii,jj,denom))
                        gvalsG(tlen)=img(ii,jj,denom);
                    end
                    if(~satMap(ii,jj,other))
                        gvalsB(tlen)=img(ii,jj,other);
                    end
                    number = 3;
                end
                    
              end
           end
        end
        
        t_valR = 0; t_valG = 0; t_valB = 0; 
        if(~satMap(i,j,num)   | number == 3) t_valR=img(i,j,num);  end
        if(~satMap(i,j,denom) | number == 3) t_valG=img(i,j,denom);end
        if(~satMap(i,j,other) | number == 3) t_valB=img(i,j,other);end    
        gvalsR(tlen+1)=t_valR;gvalsG(tlen+1)=t_valG;gvalsB(tlen+1)=t_valB;
        
        c_varR=mean((gvalsR(1:tlen+1)-mean(gvalsR(1:tlen+1))).^2);
        c_varG=mean((gvalsG(1:tlen+1)-mean(gvalsG(1:tlen+1))).^2);
        c_varB=mean((gvalsB(1:tlen+1)-mean(gvalsB(1:tlen+1))).^2);
        csigR=c_varR*0.6;csigG=c_varG*0.6;csigB=c_varB*0.6;

        mgvR=min((gvalsR(1:tlen)-t_valR).^2);
        mgvG=min((gvalsG(1:tlen)-t_valG).^2);
        mgvB=min((gvalsB(1:tlen)-t_valB).^2);
        if (csigR<(-mgvR/log(0.01)))
            csigR=-mgvR/log(0.01);
        end
        if (csigR<0.002)
            csigR=0.002;
        end
        if (csigG<(-mgvG/log(0.01)))
            csigG=-mgvG/log(0.01);
        end
        if (csigG<0.002)
            csigG=0.002;
        end
        if (csigB<(-mgvB/log(0.01)))
            csigB=-mgvB/log(0.01);
        end
        if (csigB<0.002)
            csigB=0.002;
        end
        
        gvalsR(1:tlen)=exp(-(gvalsR(1:tlen)-t_valR).^2/csigR);
        gvalsG(1:tlen)=exp(-(gvalsG(1:tlen)-t_valG).^2/csigG);
        gvalsB(1:tlen)=exp(-(gvalsB(1:tlen)-t_valB).^2/csigB);
        
        gvalsR(1:tlen)=gvalsR(1:tlen)/sum(gvalsR(1:tlen));
        gvalsG(1:tlen)=gvalsG(1:tlen)/sum(gvalsG(1:tlen));
        gvalsB(1:tlen)=gvalsB(1:tlen)/sum(gvalsB(1:tlen));

        if(satMap(i,j,num) & number ~= 3)
            gvalsR(1:tlen)=sparse([],[],[],1,tlen);
        end
        if(satMap(i,j,denom) & number ~= 3)
            gvalsG(1:tlen)=sparse([],[],[],1,tlen);
        end
        if(satMap(i,j,other) & number ~= 3)
            gvalsB(1:tlen)=sparse([],[],[],1,tlen);
        end

        vals(len-tlen+1:len)=-(gvalsR(1:tlen)+gvalsG(1:tlen)+gvalsB(1:tlen))./number;
        
        gvalsR=temp;
        gvalsG=temp;
        gvalsB=temp;

      end

      len=len+1;
      row_inds(len)= consts_len;
      col_inds(len)=indsM(i,j);
      vals(len)=1; 

   end
end

vals=vals(1:len);
col_inds=col_inds(1:len);
row_inds=row_inds(1:len);

A=sparse(row_inds,col_inds,vals,consts_len,imgSize);
b=zeros(size(A,1),1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Avoiding Matrix A becoming singular
A=A+0.00001*speye(size(A,1));

% Solving the system
b(lblInds)=alpha(lblInds);
X=A\b;