% Created by: Syed Zain Masood
% Date: 30th April, 2009
% This code is intended to remove saturation effects from photographs

%% Saturation Removal

sat_lvl1 = 235;
sat_lvl2 = 0;
imgname = 'img1.tiff';

disp('Removing Saturation ...');

% Read in saturated image
img_sat = double(imread(imgname));

% Finding out which pixels are saturated.
satMap = double((img_sat >= sat_lvl1) + (img_sat <= sat_lvl2));

% Obtain saturation-free image
img_unsat = SaturationRemoval(img_sat,satMap); %,sat_lvl1,imgname(1:end-5),prefix

% Normalizing image w.r.t the maximum value
mx = max(img_unsat(:));
img_unsat = img_unsat./max(img_unsat(:));

% Saving the saturation-free image.
imwrite(img_unsat,[imgname(1:end-5) '_unsat.bmp'],'bmp');
% imwrite((img_sat./mx),[imgname(1:end-5) '_sat.bmp'],'bmp');